#import "ReaderViewController.h"
#import "Constants.h"
#import "CoreDataStack.h"
#import "LogDataSource.h"

@interface ReaderViewController ()
@property(nonatomic,strong) CoreDataStack *coreDataStack;
@property(nonatomic,strong) LogDataSource *logDataSource;
@end

@implementation ReaderViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    NSURL *storageURL = [[NSFileManager defaultManager] containerURLForSecurityApplicationGroupIdentifier:AppGroupIdentifier];
    storageURL = [storageURL URLByAppendingPathComponent:DatabaseFilename];
    self.coreDataStack = [[CoreDataStack alloc] initWithStorageURL:storageURL];
    self.coreDataStack.receivesUpdates = YES;
    self.logDataSource = [[LogDataSource alloc] initWithTableView:self.tableView context:self.coreDataStack.context];
    self.tableView.dataSource = self.logDataSource;
}

@end
